<div class="container-fluid">
  <div class="col-md-12">
    <div class="box">
      <div class="box-header with-border">
        <h3 class="box-title">ALL EMS MEMOS</h3>
        <hr>
        <div class="row">
          <div class="col-sm-2">
            <div class="form-group">
              <label for="type">Recent Status</label>
              <select id="recentStatus"
                      class="form-control"
                      (ngModelChange)="changeStatus($event)"
                      [(ngModel)]="selectedRecentStatus"
                      name="recentStatus">
                <option *ngFor="let event of (recentStatus); let i = index"
                        [ngValue]="(recentStatus)[i]"
                >{{(recentStatus)[i]}}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label>From Date </label><br>
              <p-calendar name="date"
                          [minDate]="minFromDate"
                          [showIcon]="false"
                          [(ngModel)]="fromDate"
              >
              </p-calendar>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label>To Date </label><br>
              <p-calendar name="date"
                          [minDate]="minToDate"
                          [showIcon]="false"
                          [(ngModel)]="toDate"
                          [style]="{ width: 30}"

              >
              </p-calendar>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="type">Request Type</label>
              <select id="type"
                      class="form-control"
                      (ngModelChange)="changeType($event)"
                      [(ngModel)]="type"
                      name="requestedFor">
                <option *ngFor="let event of (requestTypes); let i = index"
                        [ngValue]="(requestTypes)[i].value"
                >{{(requestTypes)[i].key}}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="debitBranch">Requested Branch</label>
              <select id="debitBranch"
                      class="form-control"
                      name="debitBranch"
                      [(ngModel)]="debitBranchId"
                      required>
                <option *ngFor="let event of (allBranch); let i = index"
                        [ngValue]="(allBranch)[i].branchId"
                >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="requestedUser">Requested By</label>
              <select id="requestedUser"
                      class="form-control"
                      name="requestedUser"
                      [(ngModel)]="requestedUserId"
                      required>
                <option *ngFor="let event of (allUsers); let i = index"
                        [ngValue]="(allUsers)[i].userId"
                >{{(allUsers)[i].fullName + ' ( ' + (allUsers)[i].employeeId + ' )'}}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label for="memoCode">Memo Code</label>
              <input id="memoCode"
                     name="memoCode"
                     class="form-control"
                     [(ngModel)]="memoCode">
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group" style="margin-top: 27px">
              <button class=" btn btn-success" (click)="searchData()">
                <i class="pi pi-filter"></i>
                Search
              </button>
            </div>
          </div>
        </div>
      </div>
      <!-- /.box-header -->
      <div class="box-body">
        <p-table id="exportTable"
                 class="text-center"
                 [columns]="columnName"
                 [value]="(data$)"
                 [(selection)]="selectedItems"
                 [resizableColumns]="true"
                 [autoLayout]="true">

          <ng-template pTemplate="caption">
            List of Pre Approval Requests
            :&nbsp;{{ totalRecords }}
            <button class="btn btn-info btn-xs fa-pull-right"
                    (click)="downloadExcel()">
              <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
              <i class="pi pi-file-excel" style="font-size: 1em;"></i>
              Download
            </button>
          </ng-template>
          <ng-template pTemplate="header" let-columns>
            <tr>
              <th *ngFor="let col of columns" [pSortableColumn]="col.value">
                {{col.name}}
                <p-sortIcon [field]="col.value"></p-sortIcon>
              </th>
            </tr>
          </ng-template>

          <ng-template pTemplate="body" let-list let-i="rowIndex">
            <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
              <td>{{ i + 1 + itemsPerPage * page }}</td>
              <td>{{list.memoCode}}</td>
              <td>{{list.subject}}</td>
<!--              <td style="overflow-wrap: anywhere">{{list.description}}</td>-->
              <td>{{selectedRecentStatus === 'BILL_PAYMENT' ? list.currentBillPaymentStatus : list.currentPreApprovalStatus}}</td>
              <td>{{list.memoDate | date:'MMM d, y, h:mm:ss a'}}</td>
              <td>{{list.fiscalYear}}</td>
              <td>{{list.billAmount | currency: 'NPR. '}}</td>
              <td>
                <button [routerLink]="['/pre-approval', list.id, this.type]"
                   class="btn btn-success btn-xs mr-2">
                  <i class="pi pi-eye" style="font-size: 1rem"></i>
                </button>
                <button class="btn btn-danger btn-xs"
                        *ngIf="!(list.currentBillPaymentStatus === 'REJECTED' ||
                         list.currentPreApprovalStatus === 'REJECTED') && canReject"
                        (click)="rejectMemo(list.id)"
                >
                  <i class="pi pi-trash"></i>
                </button>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <p-paginator
          [rows]="itemsPerPage"
          [totalRecords]="totalRecords"
          pageLinkSize="3"
          [rowsPerPageOptions]="rowsPerPageOptions"
          (onPageChange)="paginate($event)">
        </p-paginator>
        <!-- /.row -->
      </div>
      <!-- ./box-body -->
      <div class="box-footer">
        <!-- /.row -->
      </div>
      <!-- /.box-footer -->
    </div>
    <!-- /.box -->
  </div>
  <!-- /.col -->
</div>


<p-dialog [(visible)]="showUploadFilePopUp"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Delete Memo Detail
  </p-header>
  <form [formGroup]="uploadMemoRejectionForm">
    <div class="form-group">
      <label for="file">Choose file<span class="required">*</span></label>
      <input
        id="file"
        style="width: 190px;"
        formControlName="file"
        id="file"
        [ngClass]="{ 'is-invalid': submitted && f.file.errors }"
        type="file"
        (change)="onFileChange($event)">
      <div *ngIf="submitted && f.file.errors" class="invalid-feedback">
        <div *ngIf="f.file.errors.required">File is Required.</div>
      </div>
    </div>

    <div class="form-group">
      <label for="remarks">Remarks<span class="required">*</span></label>
      <input type="text"
             id="remarks"
             formControlName="remarks"
             class="form-control"
             placeholder="Max length 50 Characters"
             [ngClass]="{ 'is-invalid': submitted && f.remarks.errors }"
             maxlength="50"
             required>
      <div *ngIf="submitted && f.remarks.errors" class="invalid-feedback">
        <div *ngIf="f.remarks.errors.required">Remarks is required</div>
      </div>
    </div>

    <div class="form-group">
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs btn-block" (click)="submitUploadForm()">
            Submit
            <span *ngIf="loadingFileUpload" class="spinner-border spinner-border-sm mr-1"></span>
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-xs btn-block" (click)="cancelSubmit()"> Cancel</button>
        </div>
      </div>
    </div>
  </form>
</p-dialog>
